// prtoken.c  base code from token-s.txt of som-v5  26 Oct 2010

#include "compile.h"

extern char strbuf[];

// print-string of token
PRIVATE char tok_str[][8] = {
	"*", "/", "-", "+", "=", "==", "&", "&&", "|", "||",
	"!", "!=", "<", "<=", ">", ">=", "<<", ">>", "%", "^",
	",", ";", "(", ")", "[", "]", "{", "}",
	"if", "else", "while", "return", "print", "def", "sys",
	"fun", "call", "do", "vec", "mac",
	"-", "!", "*", "&"
};
/*
// print token
PRIVATE void prtoken(int tk){
    if( tk > tkADS )
        seterror("unknown token");
    else if( tk >= tkSTAR )
        printf("%s",tok_str[tk-tkSTAR]); // 0..32
	else {
		switch(tk){
		case tkIDEN: printf("%s", tokstring); break;
		case tkNUMBER: printf("%s", tokstring); break;
        case tkSTRING: printf("%c%s%c",34,tokstring,34); break;
		case tkEOF: printf("eof"); break;
		}
	}
}

// print atom
PRIVATE void pratom(int a){
	int type, ref;
	type = car(a);
	ref = cdr(a);
	switch(type){
	case SP: printf("NIL"); break;
	case OPER: prtoken(ref); break;
	case ADS: printf("$%d", ref); break;
	case NUM: printf("%d", ref); break;
	case GNAME: printf("%s",getName(ref)); break;
	case LNAME: printf("#%d", ref); break;
	case STRING: printf("%c%s%c",34,&strbuf[ref],34); break;
	}
}

void printList(int a){
    if( a == NIL ) return;
    if( isatom(a) ){
        pratom(a);
        printf(" ");
    }else{
		printf("(");
		while( a != NIL ){
			printList(car(a));
			a = cdr(a);
		}
		printf(")");
	}
}

void myprtoken(int tk){
	prtoken(tk);
	printf(" ");
}
*/
// parameterized print to output
#define out0(str)				sprintf(ob,str); outCode()
#define out1(str,a1)			sprintf(ob,str,a1); outCode()
#define out2(str,a1,a2)			sprintf(ob,str,a1,a2); outCode()
#define out3(str,a1,a2,a3)		sprintf(ob,str,a1,a2,a3); outCode()
#define out4(str,a1,a2,a3,a4) 	sprintf(ob,str,a1,a2,a3,a4); outCode()

void outCode(void);
extern char ob[];
	
// print token
PRIVATE void prtoken2(int tk){
    if( tk > tkADS )
        seterror("unknown token");
    else if( tk >= tkSTAR ){
        out1("%s",tok_str[tk-tkSTAR]); // 0..32
	}else {
		switch(tk){
		case tkIDEN: out1("%s", tokstring); break;
		case tkNUMBER: out1("%s", tokstring); break;
        case tkSTRING: out3("%c%s%c",34,tokstring,34); break;
		case tkEOF: out0("eof"); break;
		}
	}
}

// print atom
PRIVATE void pratom2(int a){
	int type, ref;
	type = car(a);
	ref = cdr(a);
	switch(type){
	case SP: out0("NIL"); break;
	case OPER: prtoken2(ref); break;
	case ADS: out1("$%d", ref); break;
	case NUM: out1("%d", ref); break;
	case GNAME: out1("%s",getName(ref)); break;
	case LNAME: out1("#%d", ref); break;
	case STRING: out3("%c%s%c",34,&strbuf[ref],34); break;
	}
}

void printList2(int a){
    if( a == NIL ) return;
    if( isatom(a) ){
        pratom2(a);
        out0(" ");
    }else{
		out0("(");
		while( a != NIL ){
			printList2(car(a));
			a = cdr(a);
		}
		out0(")");
	}
}


